/* omflibam.c (emx+gcc) */

/* Add an OBJ module to an OMFLIB.

Copyright (c) 1993 Eberhard Mattes

This file is part of the emx OMFLIB library.  This library is free
software; you can redistribute it and/or modify it under the terms of
the GNU Library General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your
option) any later version.  This library is distributed in the hope
that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU Library General Public License for more details.
You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free Software
Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

As a special exception, programs written by Eberhard Mattes can use
this library without restrictions unless changed by someone else. */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "omflib0.h"
#include "omflib.h"

int omflib_add_module (struct omflib *p, const char *fname, char *error)
{
  FILE *f;
  char name[256];
  char obj_fname[256+4];
  int ret;

  omflib_module_name (name, fname);
  _strncpy (obj_fname, fname, 256);
  _defext (obj_fname, "obj");
  f = fopen (obj_fname, "rb");
  if (f == NULL)
    return (omflib_set_error (error));
  ret = omflib_copy_module (p, p->f, NULL, f, name, error);
  fclose (f);
  return (ret);
}
