/* omflibcl.c (emx+gcc) */

/* Copy an OMFLIB.

Copyright (c) 1993 Eberhard Mattes

This file is part of the emx OMFLIB library.  This library is free
software; you can redistribute it and/or modify it under the terms of
the GNU Library General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your
option) any later version.  This library is distributed in the hope
that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU Library General Public License for more details.
You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free Software
Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

As a special exception, programs written by Eberhard Mattes can use
this library without restrictions unless changed by someone else. */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "omflib0.h"
#include "omflib.h"

int omflib_copy_lib (struct omflib *dst, struct omflib *src, char *error)
{
  int i;

  if (src->mod_count == -1 && omflib_make_mod_tab (src, error) != 0)
    return (-1);
  for (i = 0; i < src->mod_count; ++i)
    if (!(src->mod_tab[i].flags & FLAG_DELETED))
      {
        fseek (src->f, src->mod_tab[i].page * src->page_size, SEEK_SET);
        if (omflib_copy_module (dst, dst->f, src, src->f,
                                src->mod_tab[i].name, error) != 0)
          return (-1);
      }
  return (0);
}
