/* omflibex.c (emx+gcc) */

/* Extract a module of an OMFLIB into an OBJ file.

Copyright (c) 1993 Eberhard Mattes

This file is part of the emx OMFLIB library.  This library is free
software; you can redistribute it and/or modify it under the terms of
the GNU Library General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your
option) any later version.  This library is distributed in the hope
that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU Library General Public License for more details.
You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free Software
Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

As a special exception, programs written by Eberhard Mattes can use
this library without restrictions unless changed by someone else. */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "omflib0.h"
#include "omflib.h"


int omflib_extract (struct omflib *p, const char *name, char *error)
{
  char buf[256+4];
  int page;
  FILE *f;

  if (p->dict == NULL && omflib_read_dictionary (p, error) != 0)
    return (-1);
  page = omflib_find_module (p, name, error);
  if (page == 0)
    {
      strcpy (error, "Module not found");
      return (-1);
    }
  _strncpy (buf, name, 255);
  _defext (buf, "obj");
  f = fopen (buf, "wb");
  if (f == NULL)
    return (omflib_set_error (error));
  fseek (p->f, page * p->page_size, SEEK_SET);
  if (omflib_copy_module (NULL, f, p, p->f, NULL, error) != 0)
    {
      fclose (f);
      remove (buf);
      return (-1);
    }
  if (fflush (f) != 0 || fclose (f) != 0)
    return (omflib_set_error (error));
  return (0);
}
